load('sbbsdefs.js');
load('typeahead.js');
load(js.exec_dir + 'ftn-nodelist.js');

var nodelistPaths = [
	"/sbbs/xtrn/ftnnv/nodelist.*"
];

// Whether or not to search within (and display) local users' real names
var SEARCH_REALNAMES = true;

var prompt = "Sending email\r\nEnter user name, number, or email/netmail address:\r\n";

var typeaheadOptions = {
	// Input box foreground color
	'fg' : LIGHTGRAY,
	// Input box background color
	'bg' : BG_BLUE,
	// Autocomplete suggestion foreground color
	'sfg' : LIGHTGRAY,
	// Autocomplete suggestion background color
	'sbg' : BG_BLUE,
	// Highlighted autocomplete suggestion foreground color
	'hsfg' : WHITE,
	// Highlighted autocomplete suggestion background color
	'hsbg' : BG_CYAN,
	// Maximum input length
	'len' : LEN_NETMAIL,
	// Seconds of idle input to wait before querying user DB, nodelists
	'delay' : 1,
	// Minimum length of input string before datasources are queried
	'minLength' : 4
};

// Edit below this line at your own peril
var nodelist = new Nodelist();

var findLocalUsers = function(str) {
	
	var suggestions = [];

	if(str.search("@") > -1)
		return suggestions;

	str = str.toUpperCase();

	var usr = new User(1);
	for(var u = 1; u < system.lastuser; u++) {

		usr.number = u;

		if(usr.settings&USER_DELETED || usr.settings&USER_INACTIVE)
			continue;

		var alias = usr.alias.toUpperCase();
		var name = usr.name.toUpperCase();
		if(	alias.indexOf(str) > -1 ||
			str.indexOf(alias) > -1 ||
			(	SEARCH_REALNAMES &&
				name != "" &&
				(	name.indexOf(str) > -1 ||
					str.indexOf(name) > -1
				)
			)
		) {
			suggestions.push(
				{	'text' : usr.alias + (SEARCH_REALNAMES && usr.name != "" ? (" (" + usr.name + ")") : ""),
					'data' : { 
						'alias' : usr.alias,
						'name' : usr.name,
						'number' : usr.number,
						'type' : NET_NONE
					}
				}
			);
		}

	}

	return suggestions;

}

var findFTNSysops = function(str) {
	var suggestions = [];
	nodelistPaths.forEach(
		function(nlp) {
			try {
				nodelist.loadNewest(nlp);
			} catch(err) {
				log(LOG_DEBUG, err);
				return;
			}
			var results = nodelist.search(str);
			results.forEach(
				function(record) {
					var text = record.sysop + "@" + record.zone + ":" + record.host + "/" + record.number;
					suggestions.push({ 'text' : text + " (" + record.name + ")", 'data' : text });
				}
			);
		}
	);
	return suggestions;
}

var findQWKUsers = function(str) {

	var suggestions = [];

	if(!file_exists(system.data_dir + "qnet/users.dat"))
		return suggestions;

	var f = new File(system.data_dir + "qnet/users.dat");
	f.open("r");

	if(!f.is_open)
		return suggestions;

	str = str.toUpperCase();

	while(!f.eof) {
		var line = f.readln();
		if(line === null)
			continue;
		var un = truncsp(line.substr(0, 27));
		if(un.toUpperCase().indexOf(str) < 0)
			continue;
		var push = {
			'name' : un,
			'node' : truncsp(line.substr(27, 10)),
			'date' : new Date(line.substr(37, 8)),
			'route' : line.match(/\((.*?)\)$/)
		};
		push.text = push.name + "@" + (push.route === null ? push.node : push.route[1]);
		suggestions.push(push);
	}

	f.close();

	suggestions.sort(
		function(a, b) {
			return b.date.getTime() - a.date.getTime();
		}
	);

	return suggestions;

}

console.clear(LIGHTGRAY);
console.putmsg(prompt);

typeaheadOptions.datasources = [findLocalUsers, findFTNSysops, findQWKUsers];
var typeahead = new Typeahead(typeaheadOptions);
var res = typeahead.getstr();

var wm = WM_NONE;
switch(netaddr_type(typeof res == "object" ? res.text : res)) {
	case NET_NONE:
		if(typeof res == "object") {
			bbs.email(res.data.number);
			break;
		}
		var un = system.matchuser(res);
		if(un > 0) {
			bbs.email(un);
		} else {
			console.putmsg(bbs.text(390));
			console.pause();
		}
		break;
	case NET_QWK:
		wm = WM_QWKNET;
	case NET_INTERNET:
	case NET_POSTLINK:
	case NET_WWIV:
	case NET_MHS:
	case NET_FIDO:
		if(!console.noyes("Attach a file"))
			wm|=WM_FILE; // I don't know if this is valid for all net types
		bbs.netmail((typeof res == "object" ? res.text : res), wm);
		break;
	case NET_UNKNOWN:
	default:
		console.putmsg(bbs.text(183));
		console.pause();
		break;
}